--  Copyright (2008-2013) Cdric Coussinet (cedric.coussinet@nomoseed.net)
--
--  This program is free software: you can redistribute it and/or modify
--  it under the terms of the GNU Affero General Public License as published
--  by the Free Software Foundation, either version 3 of the License, or
--  (at your option) any later version.
--
--  This program is distributed in the hope that it will be useful,
--  but WITHOUT ANY WARRANTY; without even the implied warranty of
--  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
--  GNU Affero General Public License for more details.

--  You should have received a copy of the GNU Affero General Public License
--  along with this program. If not, see <http://www.gnu.org/licenses/>

with Nomo.Numerics.Fitting;

with Nomo.Interpreter.Types_Index.Ranges;

with Nomo.Interpreter.Premises_Index.Arrays;

with Nomo.Interpreter.External_Messages.Premises;

limited with Nomo.Interpreter.Internal_Events_Index.Matchmakers;

package Nomo.Interpreter.Perception_Conditions.Initialization is

   use Types_Index.Ranges;
   use Premises_Index.Premises_Index_Instance;
   use Premises_Index.Arrays;
   use External_Messages.Premises;
   use Numerics.Fitting;

   procedure Initialize (This                       : in out Perception_Condition;
                         Premises                   : in Internal_Premises;
                         Premises_Types             : in Internal_Premises_Types;
                         Properties                 : in Internal_Premises_Properties;
                         Premises_Number            : in Premise_Index;
                         Fitting_Nbr                : in Count;
                         Matchmaker_Ptr             : not null access Internal_Events_Index.Matchmakers.Matchmaker;
                         Excitatory_Specificity_Log : out Real_Accurately;
                         Inhibitory_Specificity_Log : out Real_Accurately;
                         External_Data              : in External_Premise;
                         External_Type              : in External_Type_Index);

end Nomo.Interpreter.Perception_Conditions.Initialization;
